/* GeoStats - IRC Statistical Services
** Copyright (c) 1999 Jonathan George
**  E-Mail: net@lite.net
*
** GeoStats CVS Identification
** $Id: timer.c,v 1.2 2000/06/01 02:39:59 wcampbel Exp $
*/

#include "stats.h"

static time_t last_spam;
static time_t last_stats_save;
static time_t last_lag_check;
static time_t last_html;
static int midnight = 0;
static void TimerLagCheck();

void chk()
{
	time_t current = time(NULL);

	if (me.enable_spam && current - last_spam > 300)
		TimerSpam();
	if (current - last_stats_save > 120) {
		SaveStats();
		last_stats_save = time(NULL);
	}
	if (current - ping.last_sent > 60) {
		TimerPings();
		ping.last_sent = time(NULL);
	}
	if (current - last_lag_check > 70) {
		TimerLagCheck();
		last_lag_check = time(NULL);
	}
	if (me.enable_html && current - last_html > me.html_time) {
		DumpHTML();
		last_html = time(NULL);
	}
	if (is_midnight() == 1 && midnight == 0) {
		TimerMidnight();
		midnight = 1;
	} else {
		if (midnight == 1 && is_midnight() == 0)
			midnight = 0;
	}
}

void TimerReset()
{
	time_t current = time(NULL);
	last_spam = current;
	last_stats_save = current;
	last_lag_check = current;
	last_html = current - me.html_time + 30;
}

void TimerSpam()
{
	register char c;
	register int i;
	char *t;
	User *u = finduser(s_Spam);

	srand(time(NULL));

	last_spam = time(NULL);

	t = sstrdup(s_Spam);

	bzero(s_Spam, sizeof(s_Spam));
	for (i = 0; i < sizeof(s_Spam-1); i++) {
		c = (((u_short)rand())%26)+97;
		s_Spam[i] = c;
	}
	if (servsock > 0) {
		sts(":%s NICK %s", t, s_Spam);
		Change_User(u, s_Spam);
	}

	free(t);
}

void TimerPings()
{
	register int i;
	Server *s;

#ifdef DEBUG
	log("Sendings pings...");
#endif
	ping.ulag = 0;

	for (i = 0; i < S_TABLE_SIZE; i++) {
		for (s = serverlist[i]; s; s = s->next) {
			if (!strcmp(me.name, s->name)) {
				s->ping = 0;
				continue;
			}
			sts(":%s PING %s :%s", me.name, me.name, s->name);
		}
	}
}

static void TimerLagCheck()
{
	Server *s;
	register int i;

	if (me.send_extreme_lag_notices == 0)
		return;

	for (i = 0; i < S_TABLE_SIZE; i++) {
		for (s = serverlist[i]; s; s = s->next) {
			if (s->ping > 45 && time(NULL) - s->last_announce > 30 ) {
				globops(s_StatServ, "The current network lag for server %s"
					" is \2%d\2", s->name, s->ping);
				s->last_announce = time(NULL);
			}
		}
	}
}

void TimerMidnight()
{
#ifdef DEBUG
	log("Its midnight!!! -> %s", sctime(time(NULL)));
#endif
	/* Reset Daily Statistics */
	daily.servers = me.servers;
	daily.t_servers = time(NULL);
	daily.users = me.users;
	daily.t_users = time(NULL);
	daily.opers = me.opers;
	daily.t_opers = time(NULL);
	/* end */
	ResetLogs();
}

int is_midnight()
{
	time_t current = time(NULL);
	struct tm *ltm = localtime(&current);

	if (ltm->tm_hour == 0)
		return 1;

	return 0;	
}
